package com.mortals.xhx.module.perform.service.impl;
import com.mortals.framework.model.PageInfo;
import com.mortals.framework.util.DataUtil;
import com.mortals.framework.util.StringUtils;
import com.mortals.xhx.module.staff.model.StaffEntity;
import com.mortals.xhx.module.staff.model.StaffQuery;
import com.mortals.xhx.module.staff.service.StaffService;
import org.apache.commons.collections4.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.mortals.framework.service.impl.AbstractCRUDServiceImpl;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.Context;
import com.mortals.xhx.module.perform.dao.PerformPerposeDao;
import com.mortals.xhx.module.perform.model.PerformPerposeEntity;
import com.mortals.xhx.module.perform.service.PerformPerposeService;
import lombok.extern.slf4j.Slf4j;

import java.util.List;

/**
* PerformPerposeService
* 考核目标 service实现
*
* @author zxfei
* @date 2023-05-16
*/
@Service("performPerposeService")
@Slf4j
public class PerformPerposeServiceImpl extends AbstractCRUDServiceImpl<PerformPerposeDao, PerformPerposeEntity, Long> implements PerformPerposeService {

    @Autowired
    private StaffService staffService;

    @Override
    protected void findAfter(PerformPerposeEntity params, PageInfo pageInfo, Context context, List<PerformPerposeEntity> list) throws AppException {
        if(CollectionUtils.isNotEmpty(list)){
            for (PerformPerposeEntity perposeEntity:list){
                if(StringUtils.isNotEmpty(perposeEntity.getLeaders())){
                    List<Long> staffIdList = StringUtils.converStr2Long(perposeEntity.getLeaders());
                    StaffQuery staffQuery = new StaffQuery();
                    staffQuery.setIdList(staffIdList);
                    List<StaffEntity> staffEntityList = staffService.find(staffQuery);
                    if(CollectionUtils.isNotEmpty(staffEntityList)){
                        String names = "";
                        for (StaffEntity item:staffEntityList){
                            names+=item.getName()+",";
                        }
                        perposeEntity.setLeaderNames(names.substring(0,names.length()-1));
                    }
                }
            }
        }
    }
}