package com.mortals.xhx.module.perform.service.impl;
import com.mortals.framework.model.PageInfo;
import com.mortals.xhx.common.code.CheckTypeEnum;
import com.mortals.xhx.module.perform.model.*;
import com.mortals.xhx.module.perform.service.PerformStaffConfDetailService;
import org.apache.commons.collections4.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.mortals.framework.service.impl.AbstractCRUDServiceImpl;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.Context;
import com.mortals.xhx.module.perform.dao.PerformStaffConfDao;
import com.mortals.xhx.module.perform.service.PerformStaffConfService;
import lombok.extern.slf4j.Slf4j;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
* PerformStaffConfService
* 人员自动考核信息 service实现
*
* @author zxfei
* @date 2023-05-16
*/
@Service("performStaffConfService")
@Slf4j
public class PerformStaffConfServiceImpl extends AbstractCRUDServiceImpl<PerformStaffConfDao, PerformStaffConfEntity, Long> implements PerformStaffConfService {

    @Autowired
    private PerformStaffConfDetailService performStaffConfDetailService;

    @Override
    protected void saveBefore(PerformStaffConfEntity entity, Context context) throws AppException {
        super.saveBefore(entity,context);
        if(CollectionUtils.isNotEmpty(entity.getStaffConfDetail())){
//            Map<Integer,List<PerformStaffConfDetailEntity>> groupMap = entity.getStaffConfDetail().stream().collect(Collectors.groupingBy(PerformStaffConfDetailEntity::getType));
//            if(groupMap.containsKey(CheckTypeEnum.考勤绩效.getValue())) {
//                entity.setAttendCount(groupMap.get(CheckTypeEnum.考勤绩效.getValue()).size());
//            }else {
//                entity.setAttendCount(0);
//            }
//            if(groupMap.containsKey(CheckTypeEnum.评价绩效.getValue())) {
//                entity.setAssessCount(groupMap.get(CheckTypeEnum.评价绩效.getValue()).size());
//            }else {
//                entity.setAssessCount(0);
//            }
//            if(groupMap.containsKey(CheckTypeEnum.办件绩效.getValue())) {
//                entity.setWorkCount(groupMap.get(CheckTypeEnum.办件绩效.getValue()).size());
//            }else {
//                entity.setWorkCount(0);
//            }
//            if(groupMap.containsKey(CheckTypeEnum.效能绩效.getValue())) {
//                entity.setEffectCount(groupMap.get(CheckTypeEnum.效能绩效.getValue()).size());
//            }else {
//                entity.setEffectCount(0);
//            }
//            if(groupMap.containsKey(CheckTypeEnum.其它绩效.getValue())) {
//                entity.setOtherCount(groupMap.get(CheckTypeEnum.其它绩效.getValue()).size());
//            }else {
//                entity.setOtherCount(0);
//            }
        }
    }

    @Override
    protected void saveAfter(PerformStaffConfEntity entity, Context context) throws AppException {
        if(CollectionUtils.isNotEmpty(entity.getStaffConfDetail())){
//            for(PerformStaffConfDetailEntity item:entity.getStaffConfDetail()){
//                item.setStaffConfId(entity.getId());
//                item.setCreateTime(entity.getCreateTime());
//                item.setCreateUser(entity.getCreateUser());
//                item.setStaffId(entity.getStaffId());
//                item.setStaffName(entity.getStaffName());
//                item.setId(null);
//            }
//            performDeptConfDetailService.save(entity.getDeptConfDetail(),context);
        }
    }

    @Override
    protected void findAfter(PerformStaffConfEntity params, PageInfo pageInfo, Context context, List<PerformStaffConfEntity> list) throws AppException {
        if(CollectionUtils.isNotEmpty(list)){
            for (PerformStaffConfEntity item:list){
                List<PerformStaffConfDetailEntity> detailEntityList = performStaffConfDetailService.find(new PerformStaffConfDetailQuery().staffConfId(item.getId()));
                item.setStaffConfDetail(detailEntityList);
            }
        }
    }
}